# Introduction

CMake provides several generators which are able to create an IDE project directly from the CMake data.

The pros of using them are multiple:

- IDE proprietary files may be **very** difficult to track properly in git, especially if two branches made their own modifications each on their side.
- It is easy to "forget" to add a file in the IDE. If this is a source file **and** you are using the IDE to compile it (not just as a text editor - which is my main use...), you will see something is amiss, but even if you compile code a missing header won't be detected (as the file does exist on the filesystem). This can be problematic when you refactor and want to search/replace stuff in all the codebase.

The cons are:

- You can't manage exactly the same level of customization, or at least not easily. Especially true if you compile/run code within the IDE.
- You may have to define your own commands so that generated IDE is usable.

The latter is especially true for generating a MoReFEM XCode project: default behaviour is to sort files in two IDE groups: "Source files" and "Include files". This doesn't sit well with MoReFEM which uses up deeply file hierarchy, and allows to repeat filenames - you basically end up with several "Exceptions.cpp" at the same level, and with hundreds of files navigation is to say the least very uneasy...

To circumvent this, several CMake macros have been defined; they may be used in the MoReFEM XCode project itself or in an external model that uses up MoReFEM (if it was generated by `configure_cmake_external_model.py` script or an equivalent CMake).

# Overlook of the CMake macros

These macros are defined in files located in `cmake` directory at root level and are lengthily documentation there. I provide just the hints of their role.

## `morefem_organize_IDE`

The role of this macro is to mimic mostly file hierarchy in the generated project.

Second and third provided argument are often the same, but may vary if you wish for instance to place several tests in a same group in XCode.

In a (simple) external model, it is rather common that all is located in a `Sources` directory.

In this case second and third arguments may simply be dots:

```
morefem_organize_IDE(MoReFEM4AcousticWave_lib . .)
```

## morefem_test_run_model_in_X_mode(s)

where `X` is *sequential*, *parallel* or *both*.

This instruction runs the model over a specified Lua file (generally with a small mesh and only few time steps to make it fast) and converts the output in Ensight format.

Concerning XCode, these macros set as well the XCode schemes - so you should be able to run directly model-related tests within the IDE.

**Warning:** That is not entirely true if same executable is used in several tests, for instance in `Elasticity` model we typically run 2D and 3D case

```cmake
morefem_test_run_model_in_both_modes(NAME ElasticityModel3D
                                     LUA ${MOREFEM_ROOT}/Sources/ModelInstances/Elasticity/demo_3d.lua
                                     EXE MoReFEM4Elasticity
                                     TIMEOUT 50)
                                     
morefem_test_run_model_in_both_modes(NAME ElasticityModel2D
                                     LUA ${MOREFEM_ROOT}/Sources/ModelInstances/Elasticity/demo_2d.lua
                                     EXE MoReFEM4Elasticity
                                     TIMEOUT 50)
```

The generated XCode scheme will in this case provide both input files; you have to untick all but one of those beginning by `-i`:

![XCode scheme](Images/XCodeScheme.png){ width=50% }

(currently there doesn't seem there is a way to untick an option at CMake generation).

